/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2009 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/
#include <stdio.h>
#include "NUC1xx.h"
#include "Driver\DrvGPIO.h"
#include "Driver\DrvUART.h"
#include "Driver\DrvSYS.h"

// GPIOE.0 -> LCD RS
// GPIOE.1 -> LCD R/W
// GPIOE.2 -> LCD E
// GPIOE.3 -> LCD PSB
// GPIOA.0 -> LCD DB0
// GPIOA.1 -> LCD DB1
// GPIOA.2 -> LCD DB2
// GPIOA.3 -> LCD DB3
// GPIOA.4 -> LCD DB4
// GPIOA.5 -> LCD DB5
// GPIOA.6 -> LCD DB6
// GPIOA.7 -> LCD DB7
#define LCD_DATA    GPIOA->DOUT
#define LCD_RS_SET  DrvGPIO_SetBit(E_GPE,0)
#define LCD_RS_CLR  DrvGPIO_ClrBit(E_GPE,0)
#define LCD_RW_SET  DrvGPIO_SetBit(E_GPE,1)
#define LCD_RW_CLR  DrvGPIO_ClrBit(E_GPE,1)
#define LCD_E_SET   DrvGPIO_SetBit(E_GPE,2)
#define LCD_E_CLR   DrvGPIO_ClrBit(E_GPE,2)
#define LCD_PSB_SET DrvGPIO_SetBit(E_GPE,3)
#define LCD_PSB_CLR DrvGPIO_ClrBit(E_GPE,3)

unsigned char  datas1[] = {"Welcome to Use"};
unsigned char  datas2[] = {"ARM Cortex-M0"};
unsigned char  datas3[] = {"NuMicro Family"};
unsigned char  datas4[] = {"NUC100 Series"};

int checkBusy(void)
{
    int busy;
    LCD_RS_CLR;
    LCD_RW_SET;
    LCD_E_SET;
    DrvSYS_Delay(20);
    busy = (LCD_DATA&0x80)>>8;  // ȡæµ״̬־
    LCD_E_CLR;
    return busy;
}

void wait()
{
    while(checkBusy());
}

void writeCmd(unsigned char cmd)
{
    wait();
    LCD_RS_CLR;             //RS = 0, ѡָĴ
    LCD_RW_CLR;
    LCD_E_CLR;
    DrvSYS_Delay(20);
    LCD_DATA = cmd;
    DrvSYS_Delay(20);
    LCD_E_SET;
    DrvSYS_Delay(20);
    LCD_E_CLR;
}

void writeData(unsigned char dat)
{
    wait();
    LCD_RS_SET;             //RS = 1, ѡݼĴ
    LCD_RW_CLR;
    LCD_E_CLR;
    DrvSYS_Delay(20);
    LCD_DATA = dat;
    DrvSYS_Delay(20);
    LCD_E_SET;
    DrvSYS_Delay(20);
    LCD_E_CLR;
}

void init()
{
    LCD_PSB_SET;            // PSB = 1,ģʽ
    writeCmd(0x30);         // . DL=1 8-λӿ
    DrvSYS_Delay(50000);
    writeCmd(0x0C);         // ʾ. D=1 ʾ
                            //           C=0 ָر
                            //           B=0 ַ˸ر
    DrvSYS_Delay(50000);
    writeCmd(0x01);         // ʾ
    DrvSYS_Delay(50000);
}
void setPosition(unsigned char x, unsigned char y)
{
    unsigned char p;
    switch(x & 0x03)
    {
        case 0: p = 0x80; break;    // һ
        case 1: p = 0x90; break;    // ڶ
        case 2: p = 0x88; break;    // 
        case 3: p = 0x98; break;    // 
    }
    p += y;
    writeCmd(p);
}

void writeString(unsigned char * str)
{
    unsigned char i = 0;
    while(str[i] != '\0')
    {
        writeData(str[i++]);
    }
}

int main (void)
{
    init();                 // ʼ LCD 12864
    setPosition(0, 0);      // λ
    writeString(datas1);    // ʾdatas1Ϣһ
    setPosition(1, 0);
    writeString(datas2);    // ʾdatas2Ϣڶ
    setPosition(2, 0);
    writeString(datas3);    // ʾdatas3Ϣ
    setPosition(3, 0);
    writeString(datas4);    // ʾdatas4Ϣ
    while(1);
}
